/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Bubulle;

import org.lwjgl.opengl.GL11;

public class Camera {
 
    // Camera constants
    private final float CAMERA_SPEED = 20.0f;
 
    // Camera position
    private float x,y,z;
 
    // Camera view properties
    private float pitch = 0, yaw = 0, roll = 0;
 
    // Mouse sensitivity
    private float mouseSensitivity = 0.25f;
 
    // Constructor
    public Camera(float x, float y, float z) {
        this.x = x;
        this.y = y;
        this.z = z;
    }
 
    // Used to change the yaw of the camera
    public void yaw(float amount) {
        this.yaw += (amount * this.mouseSensitivity);
    }
 
    // Used to change the pitch of the camera
    public void pitch(float amount) {
        this.pitch += (amount * this.mouseSensitivity);
    }
 
    // Used to change the roll of the camera
    public void roll(float amount) {
        this.roll += amount;
    }
 
    // Moves the camera forward relative to its current rotation
    public void walkForward(float distance) {
        float d = (CAMERA_SPEED * distance);
        this.x -= d * (float)Math.sin(Math.toRadians(yaw));
        this.z -= d * (float)Math.cos(Math.toRadians(yaw));
    }
 
    // Moves the camera backward relative to its current rotation
    public void walkBackwards(float distance) {
        float d = (CAMERA_SPEED * distance);
        this.x += d * (float)Math.sin(Math.toRadians(yaw));
        this.z += d * (float)Math.cos(Math.toRadians(yaw));
    }
 
    // Strafes the camera left relative to its current rotation
    public void strafeLeft(float distance) {
        float d = (CAMERA_SPEED * distance);
        this.x += d * (float)Math.sin(Math.toRadians(yaw-90));
        this.z += d * (float)Math.cos(Math.toRadians(yaw-90));
    }
 
    // Strafes the camera right relative to its current rotation
    public void strafeRight(float distance) {
        float d = (CAMERA_SPEED * distance);
        this.x += d * (float)Math.sin(Math.toRadians(yaw+90));
        this.z += d * (float)Math.cos(Math.toRadians(yaw+90));
    }
 
    public void goUp (float distance) {
        this.y += (CAMERA_SPEED * distance);
    }
 
    public void goDown (float distance) {
        this.y -= (CAMERA_SPEED * distance);
    }
 
    // Translates and rotates the matrix so that it looks through the camera
    public void lookThrough() {
        GL11.glRotatef(-pitch, 1.0f, 0.0f, 0.0f);
        GL11.glRotatef(-yaw, 0.0f, 1.0f, 0.0f);
        GL11.glTranslatef(-this.x, -this.y, -this.z);
    }
}
